View Issue Details

IDProjectCategoryView StatusLast Update
0006778Talermechant backendpublic2021-09-02 18:23
ReporterFlorian Dold Assigned ToChristian Grothoff  
PrioritynormalSeverityminorReproducibilityhave not tried
Status closedResolutionfixed 
Product Versiongit (master) 
Target Version0.8Fixed in Version0.8 
Summary0006778: merchant-lib and testing support for authentication unclear
DescriptionCurrently the merchant lib does not have any explicit support for setting and changing authentication headers. There is GNUNET_CURL_append_header, but that does not seem to allow *removing* a header. Do we want to manage authentication through this, or should the merchant lib functions take some extra context parameter for authentication?

The same concern applies the the merchant's testing lib, which currently can't easily set/remove the authentication header.

TagsNo tags attached.

Relationships

related to 0006779 closedChristian Grothoff merchant-lib does not support changing instance authentication 

Activities

Christian Grothoff

2021-03-02 23:40

manager   ~0017582

The preferred method is:
 /* initialize HTTP client */
  ctx = GNUNET_CURL_init (&GNUNET_CURL_gnunet_scheduler_reschedule,
                          &rc);
  rc = GNUNET_CURL_gnunet_rc_create (ctx);
  /* setup authorization */
  GNUNET_assert (GNUNET_OK ==
                 GNUNET_CURL_append_header (ctx,
                                            authorization));

Note that if you must change the headers (i.e. different Authorization), you should create a fresh ctx/rc each time.

Christian Grothoff

2021-04-17 19:38

manager   ~0017754

4087bfb..657d5ba adds a command to test 0006779 (posting to /private/auth).

Christian Grothoff

2021-04-17 20:08

manager   ~0017756

da25913e..0453ef45 adds a command (to taler_testing_lib) to add/update/remove an authorization header from the CURL context.

Christian Grothoff

2021-04-17 21:49

manager   ~0017757

657d5ba..08d7955 adds tests and minor bugfixes. Resolving this issue.

Christian Grothoff

2021-09-02 18:23

manager   ~0018350

Fix committed to master branch.

Related Changesets

merchant: master 08d79555

2021-04-17 21:46:53

Christian Grothoff

Details Diff
add tests and bugfixes to fix 0006778 and 0006779 Affected Issues
0006778
mod - src/backend/taler-merchant-httpd.c Diff File
mod - src/backend/taler-merchant-httpd_private-post-instances-ID-auth.c Diff File
mod - src/lib/merchant_api_delete_instance.c Diff File
mod - src/lib/merchant_api_patch_instance.c Diff File
mod - src/lib/merchant_api_post_instance_auth.c Diff File
mod - src/testing/test_merchant_api.c Diff File
mod - src/testing/testing_api_cmd_delete_instance.c Diff File
mod - src/testing/testing_api_cmd_get_product.c Diff File
mod - src/testing/testing_api_cmd_get_products.c Diff File

Issue History

Date Modified Username Field Change
2021-03-02 20:53 Florian Dold New Issue
2021-03-02 20:53 Florian Dold Status new => assigned
2021-03-02 20:53 Florian Dold Assigned To => Christian Grothoff
2021-03-02 23:40 Christian Grothoff Note Added: 0017582
2021-03-02 23:40 Christian Grothoff Assigned To Christian Grothoff => Florian Dold
2021-04-16 23:10 Christian Grothoff Assigned To Florian Dold => Christian Grothoff
2021-04-17 19:38 Christian Grothoff Note Added: 0017754
2021-04-17 19:38 Christian Grothoff Relationship added related to 0006779
2021-04-17 20:08 Christian Grothoff Note Added: 0017756
2021-04-17 21:49 Christian Grothoff Note Added: 0017757
2021-04-17 21:49 Christian Grothoff Status assigned => resolved
2021-04-17 21:49 Christian Grothoff Resolution open => fixed
2021-04-17 21:49 Christian Grothoff Fixed in Version => 0.9
2021-04-17 21:49 Christian Grothoff Target Version => 0.9
2021-07-30 13:57 Christian Grothoff Fixed in Version 0.9 => 0.8.1
2021-07-30 13:59 Christian Grothoff Target Version 0.9 => 0.8.1
2021-07-30 14:01 Christian Grothoff Fixed in Version 0.8.1 => 0.8
2021-07-30 14:02 Christian Grothoff Target Version 0.8.1 => 0.8
2021-08-24 16:23 Christian Grothoff Status resolved => closed
2021-09-02 18:22 Christian Grothoff Changeset attached => Taler-merchant master 08d79555
2021-09-02 18:23 Christian Grothoff Note Added: 0018350